﻿using Prism;
using Prism.Ioc;
using Sample1.ViewModels;
using Sample1.Views;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

[assembly: XamlCompilation(XamlCompilationOptions.Compile)]
namespace Sample1
{
    public partial class App
    {
        /* 
         * The Xamarin Forms XAML Previewer in Visual Studio uses System.Activator.CreateInstance.
         * This imposes a limitation in which the App class must have a default constructor. 
         * App(IPlatformInitializer initializer = null) cannot be handled by the Activator.
         */
        public App() : this(null) { }

        public App(IPlatformInitializer initializer) : base(initializer) { }

        protected override async void OnInitialized()
        {
            InitializeComponent();

            //if (Device.Idiom == TargetIdiom.Desktop ||
            //    Device.Idiom == TargetIdiom.Tablet)
            //{
            //    await NavigationService.NavigateAsync("MasterDetailPage2/NavigationPage/Page2");
            //}
            //else
            //{
            //    await NavigationService.NavigateAsync("NavigationPage/MasterDetailPage2Master");
            //}

            await NavigationService.NavigateAsync($"NavigationPage/Page1");
        }

        protected override void RegisterTypes(IContainerRegistry containerRegistry)
        {
            containerRegistry.RegisterForNavigation<NavigationPage>();
            containerRegistry.RegisterForNavigation<MainPage, MainPageViewModel>();
            containerRegistry.RegisterForNavigation<Page1, Page1ViewModel>();
            containerRegistry.RegisterForNavigation<Page2, Page2ViewModel>();
            containerRegistry.RegisterForNavigation<MasterDetailPage2, MasterDetailPage2ViewModel>();
            containerRegistry.RegisterForNavigation<MasterDetailPage2Master, MasterDetailPage2MasterViewModel>();
            containerRegistry.RegisterForNavigation<MasterDetailPage2Detail, MasterDetailPage2DetailViewModel>();
            containerRegistry.RegisterForNavigation<BaseNavigationPage, BaseNavigationPageViewModel>();
        }
    }
}
