﻿using Prism.Commands;
using Prism.Mvvm;
using Prism.Navigation;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Xamarin.Forms;

namespace Sample1.ViewModels
{
    public class MainPageViewModel : ViewModelBase
    {
        
        public DelegateCommand<string> RadialMenuCommand1 { get; private set; }
        public DelegateCommand<string> RadialMenuCommand2 { get; private set; }
        public DelegateCommand<string> GotoPage2 { get; private set; }


        public MainPageViewModel(INavigationService navigationService)
            : base(navigationService)
        {
            Title = "Main Page";
            RadialMenuCommand1 = new DelegateCommand<string>(RadialItemTapped1);
            RadialMenuCommand2 = new DelegateCommand<string>(RadialItemTapped2);
            GotoPage2 = new DelegateCommand<string>(OnGotoPage2);

        }

        private void RadialItemTapped2(string obj)
        {
            NavigationService.NavigateAsync("Page2");
        }

        private void OnGotoPage2(string obj)
        {
            if (Device.Idiom == TargetIdiom.Desktop ||
                Device.Idiom == TargetIdiom.Tablet)
            {
                NavigationService.NavigateAsync("MasterDetailPage2/NavigationPage/MasterDetailPage2Detail");
            }
            else
            {
                NavigationService.NavigateAsync("NavigationPage/MasterDetailPage2Master");
            }
            
        }

        private void RadialItemTapped1(string obj)
        {
            NavigationService.NavigateAsync("Page1");
        }
    }
}
