﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Text;
using Prism;
using Prism.Commands;
using Prism.Navigation;
using Sample1.Views;

namespace Sample1.ViewModels
{
    public class MasterDetailPage2MasterViewModel : ViewModelBase, INavigationAware
    {
        INavigationService _navigationService;
        public DelegateCommand<object> P1BC { get; private set; }
        public DelegateCommand<object> P2BC { get; private set; }


        public ObservableCollection<MasterDetailPage2MasterMenuItem> MenuItems { get; set; }

        public MasterDetailPage2MasterViewModel(INavigationService navigationService)
               : base(navigationService)
        {
            _navigationService = navigationService;

            P1BC = new DelegateCommand<object>(OnP1BC);
            P2BC = new DelegateCommand<object>(OnP2BC);

            MenuItems = new ObservableCollection<MasterDetailPage2MasterMenuItem>();
            MenuItems.Add(new MasterDetailPage2MasterMenuItem { Id = 0, Title = "Page 1" });
            MenuItems.Add(new MasterDetailPage2MasterMenuItem { Id = 1, Title = "Page 2" });
            MenuItems.Add(new MasterDetailPage2MasterMenuItem { Id = 2, Title = "Page 3" });
            MenuItems.Add(new MasterDetailPage2MasterMenuItem { Id = 3, Title = "Page 4" });
            MenuItems.Add(new MasterDetailPage2MasterMenuItem { Id = 4, Title = "Page 5" });
        }

        private void OnP2BC(object obj)
        {
            NavigationParameters p = new NavigationParameters();
            p.Add("DetailPage", "Page2");
            _navigationService.NavigateAsync("MasterDetailPage2Detail", p);
        }

        private void OnP1BC(object obj)
        {
            NavigationParameters p = new NavigationParameters();
            p.Add("DetailPage", "Page1");
            //_navigationService.NavigateAsync("MasterDetailPage2/NavigationPage/MasterDetailPage2Detail", p);
            _navigationService.NavigateAsync("Page2", p);
        }

        //#region INotifyPropertyChanged Implementation
        //public event PropertyChangedEventHandler PropertyChanged;
        //void OnPropertyChanged([CallerMemberName] string propertyName = "")
        //{
        //    if (PropertyChanged == null)
        //        return;

        //    PropertyChanged.Invoke(this, new PropertyChangedEventArgs(propertyName));
        //}
        //#endregion

    }
}
