﻿using Prism.Commands;
using Prism.Mvvm;
using System;
using System.Collections.Generic;
using System.Linq;

namespace Sample1.ViewModels
{


    public class Page1ViewModel : BindableBase
    {
        public DelegateCommand EnableRSBC { get; set; }

        int _IREnd;
        public int RS2RangeStart
        {
            get { return _IREnd; }
            set { SetProperty(ref _IREnd, value); }
        }

        int _IRStart;
        public int RS2RangeEnd
        {
            get { return _IRStart; }
            set { SetProperty(ref _IRStart, value); }
        }

        int _IRMin;
        public int IRMin
        {
            get { return _IRMin; }
            set { SetProperty(ref _IRMin, value); }
        }

        int _IRMax;
        public int IRMax
        {
            get { return _IRMax; }
            set { SetProperty(ref _IRMax, value); }
        }

        int _IRStep;
        public int IRStep
        {
            get { return _IRStep; }
            set { SetProperty(ref _IRStep, value); }
        }

        int _IRValue;
        public int IRValue
        {
            get { return _IRValue; }
            set { SetProperty(ref _IRValue, value); }
        }

        int _IRTick;
        public int IRTick
        {
            get { return _IRTick; }
            set { SetProperty(ref _IRTick, value); }
        }

        int _RS2Min;
        public int RS2Min
        {
            get { return _RS2Min; }
            set { SetProperty(ref _RS2Min, value); }
        }

        int _RS2Max;
        public int RS2Max
        {
            get { return _RS2Max; }
            set { SetProperty(ref _RS2Max, value); }
        }

        bool _RSISVisible;
        public bool RSISVisible
        {
            get { return _RSISVisible; }
            set { SetProperty(ref _RSISVisible, value); }
        }

        public Page1ViewModel()
        {

            EnableRSBC = new DelegateCommand(OnEnableRSBC);

            SetRSValue(0);
            RSISVisible = false;
            
           
        }

        private void OnEnableRSBC()
        {
            if (RSISVisible)
            {
                RS2RangeStart = 0;
                IRMax = 0;
                IRMin = 0;
                RS2RangeEnd = 0;

                RS2Min = 0;
                RS2Max = 0;

                IRStep = 1;

                IRTick = 1;
                IRValue = 0;

                RSISVisible = false;
            }
            else
            {
                SetRSValue(1);
                RSISVisible = true;
            }

            

        }

        void SetRSValue(int aVAl)
        {
            if (aVAl > 0 )
            {
                IRMax = 525;
                IRMin = 315;
                IRTick = 5;
                IRValue = 420;
                IRStep = (IRMax - IRMin) / 5;

                RS2Min = IRMin - (IRMax - IRMin);
                RS2Max = IRMax + (IRMax - IRMin);
                RS2RangeStart = IRMin;
                RS2RangeEnd = IRMax;
            }
            else
            {
                IRMax = 52;
                IRMin = 31;
                IRTick = 5;
                IRValue = 42;
                IRStep = (IRMax - IRMin) / 5;

                RS2Min = IRMin - (IRMax - IRMin);
                RS2Max = IRMax + (IRMax - IRMin);
                RS2RangeStart = IRMin;
                RS2RangeEnd = IRMax;
            }
            
        }
    }
}
