﻿using Prism.Commands;
using Prism.Mvvm;
using Prism.Navigation;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Threading.Tasks;
using System.Timers;
using Xamarin.Forms;

namespace Sample1.ViewModels
{
    public class Page2ViewModel : ViewModelBase
    {
        public DelegateCommand<string> AddItem { get; private set; }
        public DelegateCommand<string> GotoPage1 { get; private set; }

        static int _Number = 0;

        private  ObservableCollection<Items> _ItemBucket = new ObservableCollection<Items>();
        public   ObservableCollection<Items> ItemBucket
        {
            get { return _ItemBucket; }
            set { SetProperty(ref _ItemBucket, value); }
            //set { this._ItemBucket = value; }
        }

        private Timer timer;
        public Page2ViewModel(INavigationService navigationService)
            : base(navigationService)
        { 
            AddItem = new DelegateCommand<string>(OnAddItem);
            GotoPage1 = new DelegateCommand<string>(OnGotoPage2);
            
            for ( int a = 0; a < 5; a++)
            {
                Items _Item = new Items();
                _Number++;
                _Item.Number = _Number.ToString();
                _Item.Name = "Constructor name";
                ItemBucket.Add(_Item);
            }

            timer = new System.Timers.Timer();
            timer.Interval = 10000;
            //timer.Start();
            timer.Elapsed += OnTimedEvent;
            timer.AutoReset = true;
            timer.Enabled = true;

        }

        private void OnTimedEvent(Object source, System.Timers.ElapsedEventArgs e)
        {
            Items _Item = new Items();

            Device.BeginInvokeOnMainThread(async () =>
            {
                await Task.Delay(200);
                _Number++;
                _Item.Number = _Number.ToString();
                _Item.Name = "Timer name";
                ItemBucket.Add(_Item);
            });

            //_Number++;
            //_Item.Number = _Number.ToString();
            //_Item.Name = "Timer name";
            //ItemBucket.Add(_Item);

        }

        private void OnGotoPage2(string obj)
        {
            NavigationService.NavigateAsync("Page1");
        }

        private void OnAddItem(string obj)
        {
            Items _Item = new Items();
            _Number++;
            _Item.Number = _Number.ToString();
            _Item.Name = "Any name would do";
            ItemBucket.Add(_Item);
        }
    }
}
